<?php


namespace app\cxinv\model;


use think\model\concern\SoftDelete;
class FinancialManager extends Base{
    use SoftDelete;
    protected $schema=[
        'id'=>'int',//主键，自动递增
        'code'=>'string',//订单或记录的唯一标识符
        'type'=>'int',//记录类型 1入库2出库
        'source'=>'int',//数据来源，1结算 2 线下订单
        'seller_code'=>'string',//卖方代码
        'seller_name'=>'string',//卖方名称
        'buyer_code'=>'string',//买方代码
        'buyer_name'=>'string',//买方名称
        'orderCode'=>'string',//订单编号
        'cxCode'=>'string',//客户编号
        'poCode'=>'string',//采购订单编号
        'platform_type'=>'int',//平台类型，1ToB 2ToC
        'goodNo'=>'string',//商品编号
        'goodName'=>'string',//商品名称
        'unit'=>'string',//商品单位
        'num'=>'int',//商品数量
        'goodPrice'=>'decimal',//商品单价
        'totalPrice'=>'decimal',//商品总价
        'cat_code'=>'string',//商品分类代码
        'cat_name'=>'string',//商品分类名称
        'tax'=>'decimal',//税率或税费
        'inv_fee'=>'decimal',//发票费用
        'inv_seller_code'=>'string',//发票卖方代码
        'inv_seller_name'=>'string',//发票卖方名称
        'inv_buyer_code'=>'string',//发票买方代码
        'inv_buyer_name'=>'string',//发票买方名称
        'inv_number'=>'string',//发票编号
        'inv_type'=>'string',//发票类型
        'inv_item_id'=>'int',//发票项目ID
        'inv_good_name'=>'string',//发票商品名称
        'inv_cat_code'=>'string',//发票商品分类代码
        'inv_spec'=>'string',//发票商品规格
        'inv_unit'=>'string',//发票商品单位
        'inv_num'=>'int',//发票商品数量
        'inv_subprice'=>'decimal',//发票商品子项单价
        'inv_subtotal'=>'decimal',//发票商品子项总价
        'inv_tax'=>'decimal',//发票税额
        'inv_tax_total'=>'decimal',//发票总税额
        'inv_price'=>'decimal',//发票单价
        'inv_total'=>'decimal',//发票总价
        'cat_diff'=>'int',//分类差异
        'tax_diff'=>'int',//税费差异
        'remark'=>'string',//备注或说明
        'status'=>'int',//1 正常 2异常/计提
        'apply_id'=>'int',
        'apply_name'=>'string',
        'create_time'=>'datetime',
        'update_time'=>'datetime',
        'delete_time'=>'datetime',
        ];
    protected $createTime='create_time';
    protected $updateTime='update_time';
    protected $deleteTime='delete_time';
    public static $ManagerType=[1=>'入库',2=>'出库'];
    public static $ManagerSource=[1=>'结算',2=>'线下订单'];
    public static $PlatformType=[1=>'ToB',2=>'ToC'];

}